day04
1. 两数之和
题目
给定一个整数数组 nums
和一个整数目标值 target
,请你在该数组中找出 和为目标值 target
的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6
输出:[0,1]
提示:
2 <= nums.length <= 10^4
-10^9 <= nums[i] <= 10^9
-10^9 <= target <= 10^9
只会存在一个有效答案
思路
代码实现
/**
* https://leetcode-cn.com/problems/two-sum/
*
* @author xiexu
* @create 2022-02-10 10:31 AM
*/
public class _1_两数之和 {
public int[] twoSum(int[] nums, int target) {
int[] res = new int[2];
if (nums == null || nums.length == 0) {
return res;
}
HashMap<Integer, Integer> map = new HashMap<>();
for (int i = 0; i < nums.length; i++) {
int temp = target - nums[i];
if (map.containsKey(temp)) {
res[1] = i;
res[0] = map.get(temp);
}
map.put(nums[i], i);
}
return res;
}
}
454. 四数相加 II
题目
给你四个整数数组 nums1
、nums2
、nums3
和 nums4
,数组长度都是 n
,请你计算有多少个元组 (i, j, k, l)
能满足:
0 <= i, j, k, l < n
nums1[i] + nums2[j] + nums3[k] + nums4[l] == 0
示例 1:
输入:nums1 = [1,2], nums2 = [-2,-1], nums3 = [-1,2], nums4 = [0,2]
输出:2
解释:
两个元组如下:
1. (0, 0, 0, 1) -> nums1[0] + nums2[0] + nums3[0] + nums4[1] = 1 + (-2) + (-1) + 2 = 0
2. (1, 1, 0, 0) -> nums1[1] + nums2[1] + nums3[0] + nums4[0] = 2 + (-1) + (-1) + 0 = 0
示例 2:
输入:nums1 = [0], nums2 = [0], nums3 = [0], nums4 = [0]
输出:1
提示:
n == nums1.length
n == nums2.length
n == nums3.length
n == nums4.length
1 <= n <= 200
-2^28 <= nums1[i], nums2[i], nums3[i], nums4[i] <= 2^28
思路
- 我们以存 AB 两数组之和为例。首先求出 A 和 B 任意两数之和 sumAB,以 sumAB 为 key,sumAB 出现的次数为 value,存入 hashmap 中。
- 然后计算 C 和 D 中任意两数之和的相反数 sumCD,在 hashmap 中查找是否存在 key 为 sumCD。
代码实现
/**
* https://leetcode-cn.com/problems/4sum-ii/
*
* @author xiexu
* @create 2022-02-10 8:07 PM
*/
public class _454_四数相加_II {
public int fourSumCount(int[] nums1, int[] nums2, int[] nums3, int[] nums4) {
HashMap<Integer, Integer> map = new HashMap<>();
int res = 0;
for (int i = 0; i < nums1.length; i++) {
for (int j = 0; j < nums2.length; j++) {
int sumAB = nums1[i] + nums2[j];
if (map.containsKey(sumAB)) {
map.put(sumAB, map.get(sumAB) + 1);
} else {
map.put(sumAB, 1);
}
}
}
for (int i = 0; i < nums3.length; i++) {
for (int j = 0; j < nums4.length; j++) {
int sumCD = -(nums3[i] + nums4[j]);
if (map.containsKey(sumCD)) {
res += map.get(sumCD);
}
}
}
return res;
}
}
15. 三数之和
题目
给你一个包含 n 个整数的数组 nums
,判断 nums
中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?
请你找出所有和为 0 且不重复的三元组。
注意:答案中不可以包含重复的三元组。
示例 1:
输入:nums = [-1,0,1,2,-1,-4]
输出:[[-1,-1,2],[-1,0,1]]
示例 2:
输入:nums = []
输出:[]
示例 3:
输入:nums = [0]
输出:[]
提示:
0 <= nums.length <= 3000
-10^5 <= nums[i] <= 10^5
思路
- 特判,对于数组长度 n,如果数组为 null 或者数组长度小于 3,返回 [ ]。
- 对数组进行排序。
- 遍历排序后数组:
- 若 nums[i] > 0:因为已经排序好,所以后面不可能有三个数加和等于 00,直接返回结果。
- 对于重复元素:跳过,避免出现重复解
- 令左指针 left=i+1 ,右指针 right = n − 1,当 left < right 时,执行循环:
- 当
nums[i] + nums[L] + nums[R] == 0
,执行循环,判断左界和右界是否和下一位置重复,去除重复解。并同时将L , R
移到下一位置,寻找新的解 - 若和大于 0,说明
nums[right]
太大,right 左移 - 若和小于 0,说明
nums[left]
太小,left 右移
- 当
代码实现
/**
* https://leetcode-cn.com/problems/3sum/
*
* @author xiexu
* @create 2022-02-10 9:30 PM
*/
public class _15_三数之和 {
public List<List<Integer>> threeSum(int[] nums) {
List<List<Integer>> res = new ArrayList<>();
int len = nums.length;
if (nums == null || len < 3) {
return res;
}
// 将数组进行排序
Arrays.sort(nums);
for (int i = 0; i < len; i++) {
if (nums[i] > 0) { // 如果当前数字大于0,则三数之和一定大于0,所以结束循环
break;
}
// 去重,当起始的值等于前一个元素,那么得到的结果将会和前一次相同
if (i > 0 && nums[i] == nums[i - 1]) {
continue;
}
int left = i + 1;
int right = len - 1;
while (left < right) {
int sum = nums[i] + nums[left] + nums[right];
if (sum == 0) {
ArrayList<Integer> list = new ArrayList<>();
list.add(nums[i]);
list.add(nums[left]);
list.add(nums[right]);
res.add(list);
// 去重,因为 i 不变,当此时 left 取的数的值与前一个数相同,所以不用在计算,直接跳
while (left < right && nums[left] == nums[left + 1]) {
left++;
}
// 去重,因为 i 不变,当此时 right 取的数的值与前一个相同,所以不用再计算
while (left < right && nums[right] == nums[right - 1]) {
right--;
}
// 将 左指针右移,将右指针左移
left++;
right--;
} else if (sum < 0) {
left++;
} else if (sum > 0) {
right--;
}
}
}
return res;
}
}
18. 四数之和
题目
给你一个由 n
个整数组成的数组 nums
,和一个目标值 target
。请你找出并返回满足下述全部条件且不重复的四元组 [ nums[a], nums[b], nums[c], nums[d] ]
(若两个四元组元素一一对应,则认为两个四元组重复):
0 <= a, b, c, d < n
-
a
、b
、c
和d
互不相同 nums[a] + nums[b] + nums[c] + nums[d] == target
你可以按 任意顺序 返回答案 。
示例 1:
输入:nums = [1,0,-1,0,-2,2], target = 0
输出:[[-2,-1,1,2],[-2,0,0,2],[-1,0,0,1]]
示例 2:
输入:nums = [2,2,2,2,2], target = 8
输出:[[2,2,2,2]]
提示:
1 <= nums.length <= 200
-10^9 <= nums[i] <= 10^9
-10^9 <= target <= 10^9
代码实现
/**
* https://leetcode-cn.com/problems/4sum/
*
* @author xiexu
* @create 2022-02-10 10:53 PM
*/
public class _18_四数之和 {
public List<List<Integer>> fourSum(int[] nums, int target) {
List<List<Integer>> res = new ArrayList<>();
if (nums.length < 4) {
return res;
}
Arrays.sort(nums);
for (int i = 0; i < nums.length; i++) {
if (i > 0 && nums[i] == nums[i - 1]) {
continue;
}
for (int j = i + 1; j < nums.length; j++) {
if (j > i + 1 && nums[j] == nums[j - 1]) {
continue;
}
// 双指针
int left = j + 1;
int right = nums.length - 1;
while (left < right) {
int sum = nums[i] + nums[j] + nums[left] + nums[right];
if (sum == target) {
ArrayList<Integer> list = new ArrayList<>();
list.add(nums[i]);
list.add(nums[j]);
list.add(nums[left]);
list.add(nums[right]);
res.add(list);
while (left < right && nums[left] == nums[left + 1]) {
left++;
}
while (left < right && nums[right] == nums[right - 1]) {
right--;
}
left++;
right--;
} else if (sum > target) {
right--;
} else if (sum < target) {
left++;
}
}
}
}
return res;
}
}